if select(2, UnitClass('player')) ~= "HUNTER" then
	return
end
local L = LibStub("AceLocale-3.0"):GetLocale("FeedMachine")
local FL = LibStub("FrameLib-3.0")

local FMUIMAINFRAME = nil
--~ local FMUITABS = {L["Options"],L["Foods"],L["Diets"]}
local FMUITABS = {L["Foods"],L["Diets"]}
--~ local FMUITABOPTIONFRAME = nil
local FMUITABFOODFRAME = nil
local FMUITABDIETFRAME = nil

function FeedMachine:FMUI_Show()
	if not FMUIMAINFRAME then
		FMUIMAINFRAME = self:FMUI_CreateFrame()
		self:FMUI_CreateTabs()
	end
	
--~ 	if not FMUITABOPTIONFRAME then
--~ 		FMUITABOPTIONFRAME = self:FMUI_CreateOptions(FMUIMAINFRAME,384,512)		
--~ 	end
	
	if not FMUITABFOODFRAME then
		FMUITABFOODFRAME = self:FMUI_CreateFoodLists(FMUIMAINFRAME,384,512)		
	end
	
	if not FMUITABDIETFRAME then
		FMUITABDIETFRAME = self:FMUI_CreateDiets(FMUIMAINFRAME,384,512)		
	end
	
	PanelTemplates_SetNumTabs(FMUIMAINFRAME, #FMUITABS)
	FMUIMAINFRAME.selectedTab = 1
	PanelTemplates_UpdateTabs(FMUIMAINFRAME)

	FMUITABFOODFRAME:Hide()
	FMUITABDIETFRAME:Hide()
	FMUIMAINFRAME:Hide()
--~ 	FMUITABOPTIONFRAME:Hide()
	
	FMUIMAINFRAME:Show()
	FMUITABFOODFRAME:Show()
--~ 	FMUITABOPTIONFRAME:Show()
end

function FeedMachine:FMUI_HandlerTabButton(buttonname)
	button = getglobal(buttonname)
--~ 	FMUITABOPTIONFRAME:Hide()
	FMUITABDIETFRAME:Hide()
	FMUITABFOODFRAME:Hide()
	
--~ 	if button:GetText() == L["Options"] then
--~ 		FMUITABOPTIONFRAME:Show()
	if button:GetText() == L["Foods"] then
		FMUITABFOODFRAME:Show()
	elseif button:GetText() == L["Diets"] then
		FMUITABDIETFRAME:Show()
	end
end

function FeedMachine:FMUI_CreateTabs()
	local x = 20
	local padding = 24
	for i,v in pairs(FMUITABS) do
		local b = FL:CreateFrame({frame = FL.UIOBJECT.BUTTON, name = FMUIMAINFRAME:GetName().."Tab"..i, parent = FMUIMAINFRAME, inherits = "CharacterFrameTabButtonTemplate",
									setpoint = {point = FL.ANCHOR.BOTTOMLEFT, x = x, y =45},
									value = {id = i, text = v}})
		
		PanelTemplates_TabResize(0, b)
	
		b:SetScript("OnClick", function() 
			PanelTemplates_Tab_OnClick(FMUIMAINFRAME)
			self:FMUI_HandlerTabButton(this:GetName())
		end )
		
		x = x + b:GetTextWidth() + padding
	end	
end

function FeedMachine:FMUI_CreateFrame()  	
	local f = FL:CreateFrame({frame = FL.UIOBJECT.FRAME, name = "FMUIMainFrame", parent = UIParent, width = 384, height = 512,
								strata = FL.STRATA.BACKGROUND, clamptoscreen = true, movable = true, enablemouse = true, registerfordrag = "LeftButton",
								setpoint = {point = FL.ANCHOR.CENTER, x = 0, y = 0},
								hitrectinsets = {left = 0, right = 30, top = 0, bottom = 45}})
	
--~ BACKGROUND TEXTURES	
--~ Portrait
	local portrait = FL:CreateTexture({parent = f, layer = FL.LAYER.BACKGROUND, width = 60, height = 60,
											setpoint = {point = FL.ANCHOR.TOPLEFT, x = 7, y = -6}})

	local t = nil
--~ BORDER TEXTURES	
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.BORDER, width = 256, height = 256, texture = "Interface\\PaperDollInfoFrame\\UI-Character-General-TopLeft.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 2, y = -1}})
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.BORDER, width = 128, height = 256, texture = "Interface\\PaperDollInfoFrame\\UI-Character-General-TopRight.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 258, y = -1}})
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.BORDER, width = 256, height = 256, texture = "Interface\\PaperDollInfoFrame\\UI-Character-General-BottomLeft.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 2, y = -257}})
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.BORDER, width = 128, height = 256, texture = "Interface\\PaperDollInfoFrame\\UI-Charcter-General-BottomRight.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 258, y = -257}})
--~ ARTWORK TEXTURES
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.ARTWORK, width = 256, height = 256, texture = "Interface\\TalentFrame\\HunterBeastMastery-TopLeft.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 23, y = -77}})
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.ARTWORK, width = 64, height = 256, texture = "Interface\\TalentFrame\\HunterBeastMastery-TopRight.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 279, y = -77}})
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.ARTWORK, width = 256, height = 128, texture = "Interface\\TalentFrame\\HunterBeastMastery-BottomLeft.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 23, y = -333}})
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.ARTWORK, width = 64, height = 128, texture = "Interface\\TalentFrame\\HunterBeastMastery-BottomRight.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 279, y = -333}})
--~ FONTS
	local font = FL:CreateFontString({parent = f, layer = FL.LAYER.ARTWORK, inherits = "GameFontNormal", text = L["Feed Machine"],
										setpoint = {point = FL.ANCHOR.TOP, x = 0, y = -20}})
--~ BUTTONS
	local b = FL:CreateFrame({frame = "Button", parent = f, inherits = "UIPanelCloseButton",
								setpoint = {point = FL.ANCHOR.CENTER, frame = f, relpoint = FL.ANCHOR.TOPRIGHT, x = -44, y = -25}})
--~ EVENT HANDLERS	
	b:SetScript("OnClick", function() 
		f:Hide()
	end )
	
	f:SetScript("OnDragStart", function()
		this:StartMoving()		
	end)
	f:SetScript("OnDragStop", function()
		this:StopMovingOrSizing()		
	end)
	f:SetScript("OnUpdate", function()
		if UnitExists("pet") then
			SetPortraitTexture(portrait,"pet")
		else
			portrait:SetTexture("Interface\\CharcterFrame\\TemporaryPortrait-Monster.blp")
		end
	end)	
	
	return f	
end