if select(2, UnitClass('player')) ~= "HUNTER" then
	return
end
local L = LibStub("AceLocale-3.0"):GetLocale("FeedMachine")
local FL = LibStub("FrameLib-3.0")

function FeedMachine:FMUI_CreateDiets(parent, width, height)
--~ PARENT FRAME
	local f = FL:CreateFrame({frame = FL.UIOBJECT.FRAME, name ="FeedMachineUI_Diets_Frame", parent = parent, width = width, height = height,
								setpoint = {point = FL.ANCHOR.TOPLEFT, x = 28, y = -78}})

	f:SetScript("OnShow",function() 
		FMUI_Diets_ScrollFrame_Update()
	end)
--~ SCROLL FRAME
	local sf = FL:CreateScrollFrame({name = "FeedMachineUI_Diets_ScrollFrame", parent = f, width = width-28-65, height = height-80-80,
										setpoint = {point = FL.ANCHOR.TOPLEFT}})
	
	sf:SetScript("OnVerticalScroll",function() 
		return FauxScrollFrame_OnVerticalScroll(48,FMUI_Diets_ScrollFrame_Update)
	end)
--~ ITEM BUTTONS	
	for i = 1,7 do
--~ 	PARENT FRAME
		local fsub = FL:CreateFrame({frame = FL.UIOBJECT.FRAME, parent = f, width = 305, height = 48,
										setpoint = {point = FL.ANCHOR.TOPLEFT, x = 0, y = (i-1)*-48}})
--~ 	TEXT STRINGS
		local s = FL:CreateFontString({parent = fsub, name = "FMDietButton"..i.."Text", layer = FL.LAYER.ARTWORK, inherits = "GameFontNormal",
										setpoint = {point = FL.ANCHOR.LEFT, x = 50, y = 0}})	
		s:SetTextColor(1, 0.8, 0)
--~ 	BUTTONS
		local cb = FL:CreateFrame({frame = FL.UIOBJECT.CHECKBUTTON, name = "FMDietButton"..i.."Button", parent = f, width = 37, height = 37, tt = true,
										setpoint = {point = FL.ANCHOR.TOPLEFT, x = 4, y = ((i-1)*-48)-3}})
		cb:RegisterForClicks("LeftButtonUp", "RightButtonUp")

		cb:SetScript("OnClick", function()
			if IsControlKeyDown() then
				for i,_ in pairs(self.db.profile.foodlist) do									
					if self.db.profile.foodlist[i]["diet"] == L[cb.diet] then	
						if (i == 1 and arg1 == "LeftButton") or (i == #self.db.profile.foodlist and arg1 == "RightButton") then
							return
						end
											
						if arg1 == "LeftButton" then
							self.db.profile.foodlist[i], self.db.profile.foodlist[i-1] = self:tableswap(self.db.profile.foodlist[i],self.db.profile.foodlist[i-1])
						end
						if arg1 == "RightButton" then
							self.db.profile.foodlist[i], self.db.profile.foodlist[i+1] = self:tableswap(self.db.profile.foodlist[i],self.db.profile.foodlist[i+1])
						end
						
						FMUI_Diets_ScrollFrame_Update()
					end
				end
			else
				for i,_ in pairs(self.db.profile.foodlist) do
					if self.db.profile.foodlist[i]["diet"] == L[cb.diet] then	
						self.db.profile.foodlist[i]["selected"] = not self.db.profile.foodlist[i]["selected"]
						if self.db.profile.foodlist[i]["selected"] then
							s:SetTextColor(1, 0.8, 0)						
						else
							s:SetTextColor(1, 0, 0)
						end
					end
				end
			end						
		end)	

--~ 	TEXTURES
		local t2 = FL:CreateTexture({parent = fsub, layer = FL.LAYER.BACKGROUND, texture = "Interface\\MailFrame\\MailItemBorder", width = 237, height = 48,
										setpoint = {point = FL.ANCHOR.TOPLEFT, x = 48, y = 0}})
		t2:SetTexCoord(0.1640625,1.0,0,0.75)	
		
		local t3 = FL:CreateTexture({parent = cb, layer = FL.LAYER.BACKGROUND, texture = "Interface\\Buttons\\UI-EmptySlot-White", width = 64, height = 64,
										setpoint = {point = FL.ANCHOR.CENTER}})
		
		local t4 = FL:CreateTexture({parent = cb, name = "FMDietButton"..i.."Icon", layer = FL.LAYER.ARTWORK,
										setpoint = {frame = cb}})
	end
	
	return f
end

function FMUI_Diets_ScrollFrame_Update()
	local offset
	local foodlist = FeedMachine.db.profile.foodlist
	local frame = getglobal("FeedMachineUI_Diets_ScrollFrame")
	
	FauxScrollFrame_Update(frame,#foodlist,7,48) 
		
	for i = 1,7 do
		offset = i + FauxScrollFrame_GetOffset(frame)	
		local icon = getglobal("FMDietButton"..i.."Icon")
		local button = getglobal("FMDietButton"..i.."Button")
		local text = getglobal("FMDietButton"..i.."Text")	
		if foodlist[offset]["selected"] then
			text:SetTextColor(1, 0.8, 0)				
		else
			text:SetTextColor(1, 0, 0)
		end
		
		if offset <= #foodlist then			
			button.diet = L[foodlist[offset]["diet"]]
			button.tooltip = button.diet
			text:SetText(button.diet)	
			icon:SetTexture(foodlist[offset]["icon"])			
		else
			button.diet = nil
			button.tooltip = nil
			text:SetText("")
			icon:SetTexture()
		end
	end	
end