if select(2, UnitClass('player')) ~= "HUNTER" then
	return
end
local L = LibStub("AceLocale-3.0"):GetLocale("FeedMachine")
local FL = LibStub("FrameLib-3.0")

function FeedMachine:FMUI_CreateFoodLists(parent, width, height)
--~ PARENT FRAME
	local f = FL:CreateFrame({frame = FL.UIOBJECT.FRAME, name = "FeedMachineUI_Food_Frame", parent = parent, width = width, height = height,
								setpoint = {point = FL.ANCHOR.TOPLEFT, x = 28, y = -78}})
	f:SetScript("OnShow",function() 
		FMUI_Foods_ScrollFrame_Update()
	end)
--~ DROPDOWN MENU	
	local ddb = FL:CreateFrame({frame = FL.UIOBJECT.FRAME, name = "FMFoodButtonDropDown", parent = f, inherits = "UIDropDownMenuTemplate",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 30, y = 30}})
--~ 	ddb:SetScript("OnLoad", function()
--~ 		UIDropDownMenu_SetWidth(200,this)
--~ 		UIDropDownMenu_Initialize(this, FMUI_Foods_DropDownMenu_OnLoad)
--~ 		UIDropDownMenu_SetSelectedID(FMFoodButtonDropDown, 1)
--~ 	end)
	ddb:SetScript("OnShow", function()	
		UIDropDownMenu_SetWidth(200,this)
		UIDropDownMenu_Initialize(this, FMUI_Foods_DropDownMenu_OnLoad)
		UIDropDownMenu_SetSelectedID(FMFoodButtonDropDown, 1)		
	end)
--~ CHECKBOX
	local cb2 = FL:CreateCheckButton({parent = f, tt = L["Lock food list"],
										setpoint = {point = "TOPLEFT", x = 260, y = 32},
										value = {checked = FeedMachine.db.profile.showUnknownFood}})
	
	cb2:SetScript("OnClick", function()
		FeedMachine.db.profile.showUnknownFood = cb2:GetChecked()
		FMUI_Foods_ScrollFrame_Update()		
	end)
--~ SCROLL FRAME
	local sf = FL:CreateScrollFrame({name = "FeedMachineUI_ScrollFrame", parent = f, width = width-28-65, height = height-80-80,
										setpoint = {point = FL.ANCHOR.TOPLEFT}})		
	sf:SetScript("OnVerticalScroll",function() 
		return FauxScrollFrame_OnVerticalScroll(48,FMUI_Foods_ScrollFrame_Update)
	end)
--~ ITEM BUTTONS	
	for i = 1,7 do
--~ 	PARENT FRAME
		local fsub = FL:CreateFrame({frame = FL.UIOBJECT.FRAME, parent = f, width = 305, height = 48,
										setpoint = {point = FL.ANCHOR.TOPLEFT, x = 0, y = (i-1)*-48}})
--~ 	TEXT STRINGS
		local s = FL:CreateFontString({parent = fsub, name = "FMFoodButton"..i.."Text", layer = FL.LAYER.ARTWORK, inherits = "GameFontNormal",
										setpoint = {point = FL.ANCHOR.LEFT, x = 50, y = 0}})
		s:SetTextColor(1, 0.8, 0)
--~ 	BUTTONS
		local cb = FL:CreateFrame({frame = FL.UIOBJECT.BUTTON, name = "FMFoodButton"..i.."Button", parent = f, width = 37, height = 37, tt = "", tttype = "Hyperlink",
										setpoint = {point = FL.ANCHOR.TOPLEFT, x = 4, y = ((i-1)*-48)-3}})
		cb:RegisterForClicks(FL.CLICK.LBUTTONUP, FL.CLICK.RBUTTONUP)

		cb:SetScript("OnClick", function()
--~ 		Don't change list as it is not complete.
			if not FeedMachine.db.profile.showUnknownFood then
				return
			end
			
			if getglobal("DropDownList1Button"..UIDropDownMenu_GetSelectedID(FMFoodButtonDropDown)):GetText() == "" then
				return
			end
			
			local foodlist = {}
			for i,_ in ipairs(self.db.profile.foodlist) do
				if self.db.profile.foodlist[i]["diet"] == L[getglobal("DropDownList1Button"..UIDropDownMenu_GetSelectedID(FMFoodButtonDropDown)):GetText()] then
					foodlist = self.db.profile.foodlist[i]["list"]
				end
			end

			if IsControlKeyDown() then
				for i,_ in pairs(foodlist) do				
					if foodlist[i]["id"] == cb.itemid then	
						if (i == 1 and arg1 == "LeftButton") or (i == #foodlist and arg1 == "RightButton") then
							return
						end
						
						local tmpfood = self:tablecopy(foodlist[i])
						
						if arg1 == "LeftButton" then
							foodlist[i], foodlist[i-1] = self:tableswap(foodlist[i],foodlist[i-1])
						end
						if arg1 == "RightButton" then
							foodlist[i], foodlist[i+1] = self:tableswap(foodlist[i],foodlist[i+1])
						end
						
						FMUI_Foods_ScrollFrame_Update()
					end
				end
			else	
				for i,_ in pairs(foodlist) do
					if foodlist[i]["id"] == cb.itemid then
						foodlist[i]["selected"] = not foodlist[i]["selected"]
						if foodlist[i]["selected"] then
							s:SetTextColor(1, 0.8, 0)						
						else
							s:SetTextColor(1, 0, 0)
						end
					end
				end
			end						
		end)	

--~ 	TEXTURES
		local t2 = FL:CreateTexture({parent = fsub, layer = FL.LAYER.BACKGROUND, texture = "Interface\\MailFrame\\MailItemBorder", width = 237, height = 48,
										setpoint = {point = FL.ANCHOR.TOPLEFT, x = 48, y = 0}})
		t2:SetTexCoord(0.1640625,1.0,0,0.75)	
		local t3 = FL:CreateTexture({parent = cb, layer = FL.LAYER.BACKGROUND, texture = "Interface\\Buttons\\UI-EmptySlot-White", width = 64, height = 64,
										setpoint = {point = FL.ANCHOR.CENTER}})
		local t4 = FL:CreateTexture({parent = cb, name = "FMFoodButton"..i.."Icon", layer = FL.LAYER.ARTWORK,
										setpoint = {frame = cb}})
	end
	
	return f
end

function FMUI_Foods_DropDownMenu_OnLoad() 
	for i,_ in ipairs(FeedMachine.db.profile.foodlist) do
		info            = UIDropDownMenu_CreateInfo()
		info.text       = L[FeedMachine.db.profile.foodlist[i]["diet"]]
		info.func       = FMUI_Foods_DropDownMenu_OnClick
		info.checked    = nil
		UIDropDownMenu_AddButton(info)
	end
end

function FMUI_Foods_DropDownMenu_OnClick() 
	UIDropDownMenu_SetSelectedID(FMFoodButtonDropDown,this:GetID())
	FMUI_Foods_ScrollFrame_Update()
end

function FMUI_Foods_ScrollFrame_Update()
	local offset	
	local foodlist = {}
	
	for i,_ in ipairs(FeedMachine.db.profile.foodlist) do
		if FeedMachine.db.profile.foodlist[i]["diet"] == L[getglobal("DropDownList1Button"..UIDropDownMenu_GetSelectedID(FMFoodButtonDropDown)):GetText()] then			
			if not FeedMachine.db.profile.showUnknownFood then
				tmplist = FeedMachine:tablecopy(FeedMachine.db.profile.foodlist[i]["list"])	
				for idx,_ in ipairs(tmplist) do
					local _, itemLink, _, _, _, _, _, _, _, _ = GetItemInfo(tmplist[idx]["id"])
					if itemLink then						
						table.insert(foodlist,tmplist[idx])												
					end										
				end	
			else
				foodlist = FeedMachine.db.profile.foodlist[i]["list"]
			end						
			break
		end
	end
	
	local frame = getglobal("FeedMachineUI_ScrollFrame")
	
	FauxScrollFrame_Update(frame,#foodlist,7,48) 
		
	for i = 1,7 do
		offset = i + FauxScrollFrame_GetOffset(frame)	
		local icon = getglobal("FMFoodButton"..i.."Icon")
		local button = getglobal("FMFoodButton"..i.."Button")
		local text = getglobal("FMFoodButton"..i.."Text")	
		if offset <= #foodlist then			
			local itemName, itemLink, _, _, _, _, _, _, _, invTexture = GetItemInfo(foodlist[offset]["id"])
			button.itemid = foodlist[offset]["id"]
			button.tooltip = itemLink
			if foodlist[offset]["selected"] then
				text:SetTextColor(1, 0.8, 0)				
			else
				text:SetTextColor(1, 0, 0)
			end
			if itemLink then	
				text:SetText(itemName)
				icon:SetTexture(invTexture)								
			else		
				if foodlist[offset]["id"] then
					text:SetText(L["Unknown Item ID"].." : "..foodlist[offset]["id"])						
					icon:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark")													
				else
					text:SetText("")
					icon:SetTexture()
				end
			end
		else
			button.itemid = nil
			button.tooltip = nil
			text:SetText("")
			icon:SetTexture()
		end
	end	
end